
#ifndef CONFIGURATION_H
#define CONFIGURATION_H

#include "../ax25/ax25.h"
/* 
 * Define Spino configuration
 */

#define SSID_SPINO_TMTC 15
#define SSID_SPINO_DIGIPEATER 3 
#define SSID_SPINO_MAILBOX 2
#define SSID_SPINO_CUBESAT 4
#define SSID_SPINO_EXPERIMENTAL 5

#define RESET_CAUSE_STATE_UNKNOWN 1

typedef struct configuration {

	long spinoTxFrequency;
	long spinoRxFrequency;
	unsigned short spinoTxModemSpeed;
	unsigned short spinoRxModemSpeed;
	unsigned char spinoRXModemMode;
	unsigned char spinoTXModemMode;
	unsigned char telemetryDelay; /* delay in seconde */
	unsigned char spare; /* delay in seconde */
	unsigned char info_message_actif;
	unsigned char delay_info_message;
	unsigned char spinoSrcCallsign[CALLSIGN_SIZE];
	unsigned char spinoDesCallsign[CALLSIGN_SIZE];
	unsigned char payloadCallsign[CALLSIGN_SIZE];
} s_configuration_spino;

typedef struct globalVariable {

	unsigned long nbCommandeReceived;
	unsigned long nbCommandeWithError;
	unsigned long nbFrameNotprocessed;
	unsigned long nbDigipeaterMesssageProcessed;
	unsigned long long timestamps;
	unsigned short lastResetCause;
	unsigned short currentState;
} s_globalVariable;

#endif // CONFIGURATION_H

